#version 330

uniform vec4 ambient;
uniform vec4 diffuse;
uniform vec4 specular;
uniform float spotCosCutoff[10];
uniform vec4 lightPos[10];
uniform sampler2D colorTexture;
uniform vec4 fog_color;
uniform float fog_start;
uniform float fog_end;
uniform vec4 frontLightColor;

in vec3 spot[10];
in vec3 normal, vertex;
in vec2 textCoords;

out vec4 fragColor;

void main(void) 
{
	vec4 outColor;
	vec3 N = normalize(normal);
	vec3 E = normalize(-vertex);
	float att; //TODO richtig berechnen
	
	vec4 diff = vec4(0,0,0,1);
	vec4 spec = vec4(0,0,0,1);

	for(int i=0;i<2;i++) {
		vec3 L = normalize(vec3(lightPos[i]) - vertex);
		float NdotL = max(0.0, dot(N,L));
		vec3 R = normalize(-reflect(L,N));

		if(NdotL > 0.0) {
			float spotEffect = dot(normalize(-L), normalize(spot[i]));
		
			if (spotEffect > spotCosCutoff[i]) {
				spotEffect = pow(spotEffect, 8.0);
				att = spotEffect/0.7;

				diff += att * diffuse * NdotL;
				diff *= vec4(0.99,0.99,0.6,1);
				diff = clamp(diff, 0.0, 1.0);
			
				spec += att * specular * pow(max(dot(R,E),0.0),80.0);
				spec = clamp(spec, 0.0, 1.0);

			}
		}
	}

	for(int i=3;i<10;i++) {
		vec3 L = normalize(vec3(lightPos[i]) - vertex);
		float NdotL = max(0.0, dot(N,L));
		vec3 R = normalize(-reflect(L,N));

		if(NdotL > 0.0) {
			float spotEffect = dot(normalize(-L), normalize(spot[i]));
		
			if (spotEffect > spotCosCutoff[i]) {
				spotEffect = pow(spotEffect, 8.0);
				att = spotEffect/0.7;

				diff += att * diffuse * NdotL;
				diff = clamp(diff, 0.0, 1.0);
			
				spec += att * specular * pow(max(dot(R,E),0.0),120.0);
				spec = clamp(spec, 0.0, 1.0);
			}
		}
	}

	outColor = clamp(ambient + diff, 0.0, 1.0) * vec4(texture2D(colorTexture, textCoords.st).rgb , 1);
	outColor.rgb += spec.rgb;
	
	float fog = clamp((fog_end + vertex.z) / (fog_end - fog_start), 0.0, 1.0);
	fragColor = mix(fog_color, outColor, fog);
	//fragColor = fog * outColor + (1-fog) * fog_color;
	//fragColor = outColor;
}

